/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * This code developed by The Department of Biomedical and Health Informatics at 
 * at the University of Washington (http://www.bhi.washington.edu)
 *
 */
 
package edu.washington.bhi.protegex.storage.xml;

import org.w3c.dom.*;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;


public class XMLImporter extends XMLBase{


	//variables	
	protected Document doc;
	
	//root node for the DOM tree
	protected Element main;
	
    boolean validation = false;

	//initialize function
	public XMLImporter()
	{
	}

	
	protected Node loadfromFile(String fileName) {
				try
	    {
	    	//Create Document
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            dbf.setNamespaceAware(true);
            dbf.setValidating(false);
            dbf.setIgnoringElementContentWhitespace(false);
            DocumentBuilder db = dbf.newDocumentBuilder();
            doc = db.parse(fileName);

	    }   
	    catch(Exception e)
	    {
	        printErrorMessage("Errors " + e); 
	    }
	    	    
	    return doc;
	}
	
	protected void getAttributes(Node node) {
	}
	
	protected String getAttribute(Node node, String attribute) {
		String value = "";

		NamedNodeMap nnm = node.getAttributes();
        if(nnm != null )
        {
            int len = nnm.getLength();
            Attr attr;
            for ( int i = 0; i < len; i++ )
            {
                attr = (Attr)nnm.item(i);
                if (attr.getNodeName().equals(attribute)) {
                	value = attr.getNodeValue();
                }
            }
        }	
        
        return value;	
	}
	protected String getTextnodevalue(Node node) {
		String text = "";
		
		if (node != null) {
		
			Node textnode = node.getFirstChild();
			
			if (textnode != null) {
				if (textnode.getNodeType() == Node.TEXT_NODE) {
					text = textnode.getNodeValue();
				}
				else {
					//cheesy: error handling not implemented, return empty string for now for NULL
					printErrorMessage("Text Node not configured correctly");
					text = "";
				}
			}
		}	
		
		return text;
	}

}	